class Webui::ApidocsController < Webui::WebuiController

  include Webui::WebuiHelper
  # Apidocs is insensitive static information, no login needed therefore
  skip_before_filter :extract_user
  
  # the main purpose of this subfunction is easier stubing
  def indexpath
    filename = File.expand_path(CONFIG['apidocs_location']) + "/index"
    if !File.exist?( filename + ".html" )
      return nil
    else
      return filename
    end
  end

  def index
    filename = indexpath
    unless filename
      flash[:error] = "Unable to load API documentation source file: #{CONFIG['apidocs_location']}"
      redirect_back_or_to :controller => 'main', :action => 'index'
    else
      render :file => filename, formats: [:html]
    end
  end

  def file
    # Ensure it really is just a file name, no '/..', etc.
    filename = File.basename(params[:filename])
    file = File.expand_path( File.join(CONFIG['schema_location'], filename) )
    if File.exist?( file )
      send_file( file, :type => "text/xml", :disposition => "inline" )
    else
      flash[:error] = "File not found: #{params[:filename]}"
      redirect_back_or_to :controller => 'apidocs', :action => 'index'
    end
    return
  end

end
